﻿' ------------------------------------------------------------------------------
'
' FishKurs2.VB                                            Ulrich Müller 20.06.06
'                                                         PCS1700 VB2005 Express
' Einführung in die Programmierung mit VB2005 und FishFace40
'                   am Beispiel einer Ampelsteuerung
'
' FishKurs2 : Fußgängerampel (Konsolanwendung).
'             Lampen : Grün = O1, Gelb = O2, Rot = O3, FußGrün = O4, FußRot = O5
'             Taster : Nacht = I1 (Schließer)
'
' erforderlich : FishFa2005.DLL und umFish40.DLL
'
' ------------------------------------------------------------------------------

Imports FishFace40
Module FishKurs2
  Private ft As New FishFace()
  Const oRot As Out = Out.O3
  Const oGelb As Out = Out.O2
  Const oGruen As Out = Out.O1
  Const oFussGruen As Out = Out.O4
  Const oFussRot As Out = Out.O5
  Const iNacht As Inp = Inp.I1

  Private Sub NachtZyklus()

    ' --- Gelb blinken bei Nacht ---

    ft.SetLamp(oFussRot, Dir.Aus)
    ft.SetLamp(oGelb, Dir.Ein)
    ft.Pause(700)
    ft.SetLamp(oGelb, Dir.Aus)
    ft.Pause(250)

  End Sub


  Private Sub TagZyklus()
    ' --- Normaler Ampelzyklus am Tage ---

    ft.SetLamp(oGruen, Dir.Ein)         '     Grün, 3000
    ft.SetLamp(oFussRot, Dir.Ein)
    ft.Pause(3000)
    ft.SetLamp(oGruen, Dir.Aus)
    ft.SetLamp(oGelb, Dir.Ein)          '     Gelb, 1000
    ft.Pause(1000)
    ft.SetLamp(oGelb, Dir.Aus)
    ft.SetLamp(oRot, Dir.Ein)           '     Rot, 3500
    ft.SetLamp(oFussRot, Dir.Aus)
    ft.SetLamp(oFussGruen, Dir.Ein)
    ft.Pause(3500)
    ft.SetLamp(oFussGruen, Dir.Aus)
    ft.SetLamp(oFussRot, Dir.Ein)
    ft.SetLamp(oGelb, Dir.Ein)          '     Rot/Gelb, 1000
    ft.Pause(1000)
    ft.SetLamp(oRot, Dir.Aus)
    ft.SetLamp(oGelb, Dir.Aus)

  End Sub

  Sub Main()
    Console.WriteLine("--- FishKurs2 : gestartet ---")
    Try
      ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      Console.WriteLine("--- Verbindung zum Interface hergestellt ---")
      Console.WriteLine("--- Ampelschleife läuft, Abbruch durch ESC-Taste ---")
      Do                                     ' --- Betriebsschleife Ampelanzeige ---
        Select Case TimeString
          ' --- Zyklusbestimmung, wenn man nicht warten will, auch mit iNacht
          Case #6:00:00 AM# To #10:00:00 PM#
            If ft.GetInput(iNacht) Then NachtZyklus() Else TagZyklus()
          Case Else
            NachtZyklus()
        End Select
      Loop Until ft.Finish()                  ' --- Ende durch ESC-Taste
    Catch eft As FishFaceException
      Console.WriteLine(eft.Message)
    End Try
    ft.CloseInterface()
    Console.WriteLine("--- Beenden durch RETURN ---")
    Console.ReadLine()
  End Sub

End Module
