﻿' ------------------------------------------------------------------------------
'
' FishKurs3W.VB                                           Ulrich Müller 23.06.06
'                                                         PCS1700 VB2005 Express
' Einführung in die Programmierung mit VB2005 und FishFace40
'                   am Beispiel einer Ampelsteuerung
'
' Kreuzung
'     Lampen : Grün = O1, Gelb = O2, Rot = O3, FußGrün = O4, FußRot = O5
'              QuerGrün = O6, QuerGelb = O7, QuerRot = O8
'
' erforderlich : FishFa2005.DLL und umFish40.DLL
'
' ------------------------------------------------------------------------------

Imports FishFace40

Public Class FishKurs3W

  Private ft As New FishFace()

  Const cGruen = 1, cGelb = 2, cRot = 4
  Const cFussGruen = 8, cFussRot = 16
  Const cQuerGruen = 32, cQuerGelb = 64, cQuerRot = 128

  Private ProgName As String

  Private Sub TagZyklus()
    ft.SetMotors(cGruen + cFussGruen + cQuerRot)
    ft.Pause(3500)
    ft.SetMotors(cGelb + cFussRot + cQuerGelb + cQuerRot)
    ft.Pause(1000)
    ft.SetMotors(cRot + cFussRot + cQuerGruen)
    ft.Pause(3500)
    ft.SetMotors(cGelb + cRot + cFussRot + cQuerGelb)
    ft.Pause(1000)
  End Sub

  Private Sub Blinken()
    ft.SetMotors(cGelb + cQuerGelb)
    ft.Pause(666)
    ft.ClearMotors()
    ft.Pause(333)
  End Sub

  Private Sub Abschalten()
    ft.ClearMotors()
    If MsgBox("Soll das Programm ganz abgeschaltet werden?", _
              MsgBoxStyle.YesNo, "FishKurs") = MsgBoxResult.Yes Then
      tmrAnzeige.Enabled = False
      ft.CloseInterface()
      Me.Close()
    End If
    lblRot.BackColor = Color.Gray
    lblGelb.BackColor = Color.Gray
    lblGruen.BackColor = Color.Gray
    lblFussRot.BackColor = Color.Gray
    lblFussGruen.BackColor = Color.Gray
    lblQuerRot.BackColor = Color.Gray
    lblQuerGelb.BackColor = Color.Gray
    lblQuerGruen.BackColor = Color.Gray
  End Sub

  Private Sub FishKurs3W_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    pnlTuer.Left = pnlSchrank.Left - 5
    pnlTuer.Top = pnlSchrank.Top
    Me.Width = 301
    ProgName = "Aus"
    Try
      ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      tmrAnzeige.Enabled = True
    Catch eft As FishFaceException
      MsgBox(eft.Message, MsgBoxStyle.Critical, "FishKurs")
      Me.Close()
    End Try
  End Sub

  Private Sub cmdOeffnen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOeffnen.Click
    pnlTuer.Visible = False
  End Sub

  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAction.Click
    Dim Prg As String = ProgName
    cmdAction.Enabled = False
    ft.NotHalt = False
    Do
      Select Case Prg
        Case "Blinken"
          Blinken()
        Case "Zyklus"
          If TimeString > #6:00:00 AM# And TimeString < #10:00:00 PM# Then
            TagZyklus()
          Else
            Blinken()
          End If
        Case "Aus"
          Abschalten()
          Exit Do
      End Select
    Loop Until ft.Finish()
  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    pnlTuer.Visible = True
  End Sub

  Private Sub rdoProgCheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoAus.CheckedChanged, rboZyklus.CheckedChanged, rboBlinken.CheckedChanged
    Dim R As RadioButton = sender
    ProgName = R.Tag
    ft.NotHalt = True
    cmdAction.Enabled = True
  End Sub

  Private Sub tmrAnzeige_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrAnzeige.Tick
    Dim LS As Integer = ft.Outputs
    lblRot.BackColor = IIf((LS And cRot) > 0, Color.Red, Color.Gray)
    lblGelb.BackColor = IIf((LS And cGelb) > 0, Color.Yellow, Color.Gray)
    lblGruen.BackColor = IIf((LS And cGruen) > 0, Color.Green, Color.Gray)
    lblFussRot.BackColor = IIf((LS And cFussRot) > 0, Color.Red, Color.Gray)
    lblFussGruen.BackColor = IIf((LS And cFussGruen) > 0, Color.Green, Color.Gray)
    lblQuerRot.BackColor = IIf((LS And cQuerRot) > 0, Color.Red, Color.Gray)
    lblQuerGelb.BackColor = IIf((LS And cQuerGelb) > 0, Color.Yellow, Color.Gray)
    lblQuerGruen.BackColor = IIf((LS And cQuerGruen) > 0, Color.Green, Color.Gray)
  End Sub
End Class