﻿' ------------------------------------------------------------------------------
'
' FishKurs3bW.VB                                          Ulrich Müller 24.06.06
'                                                         PCS1700 VB2005 Express
' Einführung in die Programmierung mit VB2005 und FishFace40
'                   am Beispiel einer Ampelsteuerung
'
' Kreuzung mit FußWunsch
'     Lampen : Grün = O1, Gelb = O2, Rot = O3, FußGrün = O4, FußRot = O5
'              QuerGrün = O6, QuerGelb = O7, QuerRot = O8
'
' erforderlich : FishFa2005.DLL und umFish40.DLL
'
' ------------------------------------------------------------------------------

Imports FishFace40

Public Class FishKurs3bW

  Private ft As New FishFace()

  Const cGruen = 1, cGelb = 2, cRot = 4
  Const cFussGruen = 8, cFussRot = 16
  Const cQuerGruen = 32, cQuerGelb = 64, cQuerRot = 128
  Const iFussWunsch As Inp = Inp.I1

  Private TagListe() As Integer = {cGruen + cFussRot + cQuerRot, _
                                   cGruen + cFussRot + cQuerRot, _
                                   cGruen + cFussRot + cQuerRot, _
                                   cGelb + cFussRot + cQuerGelb + cQuerRot, _
                                   cRot + cFussRot + cQuerGruen, _
                                   cGelb + cRot + cFussRot + cQuerGelb, _
                                   cGelb + cRot + cFussRot + cQuerGelb, _
                                   cGelb + cRot + cFussRot + cQuerGelb}

  Private FussListe() As Integer = {cGruen + cFussGruen + cQuerRot, _
                                   cGruen + cFussGruen + cQuerRot, _
                                   cGruen + cFussGruen + cQuerRot, _
                                   cGelb + cFussRot + cQuerGelb + cQuerRot, _
                                   cRot + cFussRot + cQuerGruen, _
                                   cGelb + cRot + cFussRot + cQuerGelb, _
                                   cGelb + cRot + cFussRot + cQuerGelb, _
                                   cGelb + cRot + cFussRot + cQuerGelb}

  Private ProgName As String
  Private FussWunsch As Boolean
  Private NextStep As Boolean

  Private Sub Zyklus(ByVal Liste() As Integer)
    For i As Integer = 0 To Liste.Length - 1
      lblSchrittNr.Text = i + 1
      ft.SetMotors(Liste(i))
      If chkEinzelSchritt.Checked Then
        NextStep = False
        Do Until NextStep Or ft.NotHalt
          ft.Pause(100)
        Loop
      Else
        ft.Pause(1000)
      End If
    Next
  End Sub

  Private Sub Blinken()
    lblSchrittNr.Text = "1"
    ft.SetMotors(cGelb + cQuerGelb)
    ft.Pause(666)
    lblSchrittNr.Text = "2"
    ft.ClearMotors()
    ft.Pause(333)
  End Sub

  Private Sub Abschalten()
    ft.ClearMotors()
    If MsgBox("Soll das Programm ganz abgeschaltet werden?", _
              MsgBoxStyle.YesNo, "FishKurs") = MsgBoxResult.Yes Then
      tmrAnzeige.Enabled = False
      ft.CloseInterface()
      Me.Close()
    End If
    lblRot.BackColor = Color.Gray
    lblGelb.BackColor = Color.Gray
    lblGruen.BackColor = Color.Gray
    lblFussRot.BackColor = Color.Gray
    lblFussGruen.BackColor = Color.Gray
    lblQuerRot.BackColor = Color.Gray
    lblQuerGelb.BackColor = Color.Gray
    lblQuerGruen.BackColor = Color.Gray
  End Sub

  Private Sub FishKurs3W_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    pnlTuer.Left = pnlSchrank.Left - 5
    pnlTuer.Top = pnlSchrank.Top
    Me.Width = 301
    ProgName = "Aus"
    FussWunsch = False
    NextStep = False
    Try
      ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      tmrAnzeige.Enabled = True
    Catch eft As FishFaceException
      MsgBox(eft.Message, MsgBoxStyle.Critical, "FishKurs")
      Me.Close()
    End Try
  End Sub

  Private Sub cmdOeffnen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOeffnen.Click
    If txtPass.Text = "FishKurs" Then pnlTuer.Visible = False
    txtPass.Text = ""
  End Sub

  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAction.Click
    Dim Prg As String = ProgName
    Dim VonZeit As DateTime = mskVonZeit.Text
    Dim BisZeit As DateTime = mskBisZeit.Text

    cmdAction.Enabled = False
    ft.NotHalt = False
    Do
      Select Case Prg
        Case "Blinken"
          Blinken()
        Case "FußZyklus"
          Zyklus(FussListe)
        Case "Zyklus"
          If TimeString > VonZeit And TimeString < BisZeit Then
            If FussWunsch Then
              Zyklus(FussListe)
              FussWunsch = False
            Else
              Zyklus(TagListe)
            End If
          Else
            Blinken()
          End If
        Case "Aus"
          Abschalten()
          Exit Do
      End Select
    Loop Until ft.Finish()
  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    pnlTuer.Visible = True
  End Sub

  Private Sub rdoProgCheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoAus.CheckedChanged, rboZyklus.CheckedChanged, rboBlinken.CheckedChanged, rboBedarf.CheckedChanged
    Dim R As RadioButton = sender
    ProgName = R.Tag
    ft.NotHalt = True
    cmdAction.Enabled = True
  End Sub

  Private Sub tmrAnzeige_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrAnzeige.Tick
    Dim LS As Integer = ft.Outputs

    If ft.GetInput(iFussWunsch) Then FussWunsch = True

    lblRot.BackColor = IIf((LS And cRot) > 0, Color.Red, Color.Gray)
    lblGelb.BackColor = IIf((LS And cGelb) > 0, Color.Yellow, Color.Gray)
    lblGruen.BackColor = IIf((LS And cGruen) > 0, Color.Green, Color.Gray)
    lblFussRot.BackColor = IIf((LS And cFussRot) > 0, Color.Red, Color.Gray)
    lblFussGruen.BackColor = IIf((LS And cFussGruen) > 0, Color.Green, Color.Gray)
    lblQuerRot.BackColor = IIf((LS And cQuerRot) > 0, Color.Red, Color.Gray)
    lblQuerGelb.BackColor = IIf((LS And cQuerGelb) > 0, Color.Yellow, Color.Gray)
    lblQuerGruen.BackColor = IIf((LS And cQuerGruen) > 0, Color.Green, Color.Gray)
  End Sub

  Private Sub cmdNextStep_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdNextStep.Click
    NextStep = True
  End Sub
End Class